package com.gic.finance.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.finance.dto.TransferAccountsApprovalDTO;

/**
 * 转账审批
 * @ClassName: TransferAccountsApprovalApiService 
 * @Description:  
 * @author guojuxing 
 * @date 2019/8/9 11:13 AM 
 */
public interface TransferAccountsApprovalApiService {

    /**
     * 发起审批
     * @Title: initiateApproval 
     * @Description: 
      * @author guojuxing 
     * @param transferAccountsApprovalDTO 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Integer> 
      */
    ServiceResponse<Integer> initiateApproval(TransferAccountsApprovalDTO transferAccountsApprovalDTO);

    /**
     * 主键查询
     * @Title: getById 
     * @Description: 
      * @author guojuxing 
     * @param transferApprovalId 
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.finance.dto.TransferAccountsApprovalDTO> 
      */
    ServiceResponse<TransferAccountsApprovalDTO> getById(Integer transferApprovalId);

    /**
     * 审批通过操作
     * @Title: agreeApproval 
     * @Description: 
      * @author guojuxing 
     * @param transferApprovalId
     * @param accountAmount 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Void> 
      */
    ServiceResponse<Void> agreeApproval(Integer transferApprovalId, Double accountAmount);

    /**
     * 回驳
     * @Title: rejectApproval 
     * @Description: 
      * @author guojuxing 
     * @param transferApprovalId 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Void> 
      */
    ServiceResponse<Void> rejectApproval(Integer transferApprovalId);

    /**
     * @Title: listTransferAccountsApproval 
     * @Description: 
      * @author guojuxing 
     * @param search
     * @param approvalStatus
     * @param enterpriseId
     * @param pageNum
     * @param pageSize 
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.api.base.commons.Page<com.gic.finance.dto.TransferAccountsApprovalDTO>> 
      */
    ServiceResponse<Page<TransferAccountsApprovalDTO>> listTransferAccountsApproval(String search, Integer approvalStatus,
                                                                                        Integer enterpriseId,
                                                                                        Integer pageNum, Integer pageSize);

    ServiceResponse<TransferAccountsApprovalDTO> getDetailById(Integer transferApprovalId);

}
